/* contacts-avatar-utils.c generated by valac 0.45.91, the Vala compiler
 * generated from contacts-avatar-utils.vala, do not modify */

/*
 * Copyright 2019 Michael Gratton <mike@vee.net>
 *
 * This software is licensed under the GNU Lesser General Public License
 * (version 2.1 or later). See the COPYING file in this distribution.
 */

#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <gdk-pixbuf/gdk-pixbuf.h>
#include <cairo.h>
#include <float.h>
#include <math.h>
#include <gdk/gdk.h>
#include <pango/pango.h>
#include <pango/pangocairo.h>
#include <gtk/gtk.h>

#define __vala_PangoFontDescription_free0(var) ((var == NULL) ? NULL : (var = (_vala_PangoFontDescription_free (var), NULL)))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
#define _cairo_destroy0(var) ((var == NULL) ? NULL : (var = (cairo_destroy (var), NULL)))
#define _cairo_surface_destroy0(var) ((var == NULL) ? NULL : (var = (cairo_surface_destroy (var), NULL)))
#define _g_string_free0(var) ((var == NULL) ? NULL : (var = (g_string_free (var, TRUE), NULL)))

GdkPixbuf* contacts_avatar_utils_generate_user_picture (const gchar* name,
                                                        gint size,
                                                        gboolean label);
void contacts_avatar_utils_get_color_for_name (const gchar* name,
                                               GdkRGBA* result);
gchar* contacts_avatar_utils_extract_initials_from_name (const gchar* name);
static void _vala_PangoFontDescription_free (PangoFontDescription* self);
GdkPixbuf* contacts_avatar_utils_round_image (GdkPixbuf* source);

static void
_vala_PangoFontDescription_free (PangoFontDescription* self)
{
#line 38 "../src/contacts-avatar-utils.vala"
	g_boxed_free (pango_font_description_get_type (), self);
#line 46 "contacts-avatar-utils.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 51 "../src/contacts-avatar-utils.vala"
	return self ? g_object_ref (self) : NULL;
#line 54 "contacts-avatar-utils.c"
}

GdkPixbuf*
contacts_avatar_utils_generate_user_picture (const gchar* name,
                                             gint size,
                                             gboolean label)
{
	GdkPixbuf* result = NULL;
	cairo_surface_t* surface = NULL;
	cairo_surface_t* _tmp0_;
	cairo_t* cr = NULL;
	cairo_surface_t* _tmp1_;
	cairo_t* _tmp2_;
	cairo_t* _tmp3_;
	GdkRGBA color = {0};
	GdkRGBA _tmp4_ = {0};
	cairo_t* _tmp5_;
	GdkRGBA _tmp6_;
	GdkRGBA _tmp7_;
	GdkRGBA _tmp8_;
	cairo_t* _tmp9_;
	cairo_surface_t* _tmp48_;
	GdkPixbuf* _tmp49_;
	GError* _inner_error0_ = NULL;
#line 15 "../src/contacts-avatar-utils.vala"
	g_return_val_if_fail (name != NULL, NULL);
#line 16 "../src/contacts-avatar-utils.vala"
	_tmp0_ = cairo_image_surface_create (CAIRO_FORMAT_ARGB32, size, size);
#line 16 "../src/contacts-avatar-utils.vala"
	surface = _tmp0_;
#line 19 "../src/contacts-avatar-utils.vala"
	_tmp1_ = surface;
#line 19 "../src/contacts-avatar-utils.vala"
	_tmp2_ = cairo_create (_tmp1_);
#line 19 "../src/contacts-avatar-utils.vala"
	cr = _tmp2_;
#line 20 "../src/contacts-avatar-utils.vala"
	_tmp3_ = cr;
#line 20 "../src/contacts-avatar-utils.vala"
	cairo_rectangle (_tmp3_, (gdouble) 0, (gdouble) 0, (gdouble) size, (gdouble) size);
#line 23 "../src/contacts-avatar-utils.vala"
	contacts_avatar_utils_get_color_for_name (name, &_tmp4_);
#line 23 "../src/contacts-avatar-utils.vala"
	color = _tmp4_;
#line 24 "../src/contacts-avatar-utils.vala"
	_tmp5_ = cr;
#line 24 "../src/contacts-avatar-utils.vala"
	_tmp6_ = color;
#line 24 "../src/contacts-avatar-utils.vala"
	_tmp7_ = color;
#line 24 "../src/contacts-avatar-utils.vala"
	_tmp8_ = color;
#line 24 "../src/contacts-avatar-utils.vala"
	cairo_set_source_rgb (_tmp5_, _tmp6_.red / 255.0, _tmp7_.green / 255.0, _tmp8_.blue / 255.0);
#line 27 "../src/contacts-avatar-utils.vala"
	_tmp9_ = cr;
#line 27 "../src/contacts-avatar-utils.vala"
	cairo_fill (_tmp9_);
#line 30 "../src/contacts-avatar-utils.vala"
	if (label) {
#line 115 "contacts-avatar-utils.c"
		gchar* initials = NULL;
		gchar* _tmp10_;
		const gchar* _tmp11_;
#line 31 "../src/contacts-avatar-utils.vala"
		_tmp10_ = contacts_avatar_utils_extract_initials_from_name (name);
#line 31 "../src/contacts-avatar-utils.vala"
		initials = _tmp10_;
#line 32 "../src/contacts-avatar-utils.vala"
		_tmp11_ = initials;
#line 32 "../src/contacts-avatar-utils.vala"
		if (_tmp11_ != NULL) {
#line 127 "contacts-avatar-utils.c"
			gchar* font = NULL;
			gchar* _tmp12_;
			cairo_t* _tmp13_;
			PangoLayout* layout = NULL;
			cairo_t* _tmp14_;
			PangoLayout* _tmp15_;
			PangoLayout* _tmp16_;
			const gchar* _tmp17_;
			PangoLayout* _tmp18_;
			const gchar* _tmp19_;
			PangoFontDescription* _tmp20_;
			PangoFontDescription* _tmp21_;
			gint width = 0;
			gint height = 0;
			PangoLayout* _tmp22_;
			gint _tmp23_ = 0;
			gint _tmp24_ = 0;
			cairo_t* _tmp25_;
			cairo_t* _tmp26_;
			cairo_t* _tmp27_;
			PangoLayout* _tmp28_;
#line 33 "../src/contacts-avatar-utils.vala"
			_tmp12_ = g_strdup_printf ("Cantarell Ultra-Bold %d", (gint) ceil ((gdouble) (size / 3)));
#line 33 "../src/contacts-avatar-utils.vala"
			font = _tmp12_;
#line 35 "../src/contacts-avatar-utils.vala"
			_tmp13_ = cr;
#line 35 "../src/contacts-avatar-utils.vala"
			cairo_set_source_rgb (_tmp13_, 1.0, 1.0, 1.0);
#line 36 "../src/contacts-avatar-utils.vala"
			_tmp14_ = cr;
#line 36 "../src/contacts-avatar-utils.vala"
			_tmp15_ = pango_cairo_create_layout (_tmp14_);
#line 36 "../src/contacts-avatar-utils.vala"
			layout = _tmp15_;
#line 37 "../src/contacts-avatar-utils.vala"
			_tmp16_ = layout;
#line 37 "../src/contacts-avatar-utils.vala"
			_tmp17_ = initials;
#line 37 "../src/contacts-avatar-utils.vala"
			pango_layout_set_text (_tmp16_, _tmp17_, -1);
#line 38 "../src/contacts-avatar-utils.vala"
			_tmp18_ = layout;
#line 38 "../src/contacts-avatar-utils.vala"
			_tmp19_ = font;
#line 38 "../src/contacts-avatar-utils.vala"
			_tmp20_ = pango_font_description_from_string (_tmp19_);
#line 38 "../src/contacts-avatar-utils.vala"
			_tmp21_ = _tmp20_;
#line 38 "../src/contacts-avatar-utils.vala"
			pango_layout_set_font_description (_tmp18_, _tmp21_);
#line 38 "../src/contacts-avatar-utils.vala"
			__vala_PangoFontDescription_free0 (_tmp21_);
#line 41 "../src/contacts-avatar-utils.vala"
			_tmp22_ = layout;
#line 41 "../src/contacts-avatar-utils.vala"
			pango_layout_get_size (_tmp22_, &_tmp23_, &_tmp24_);
#line 41 "../src/contacts-avatar-utils.vala"
			width = _tmp23_;
#line 41 "../src/contacts-avatar-utils.vala"
			height = _tmp24_;
#line 42 "../src/contacts-avatar-utils.vala"
			_tmp25_ = cr;
#line 42 "../src/contacts-avatar-utils.vala"
			cairo_translate (_tmp25_, (gdouble) (size / 2), (gdouble) (size / 2));
#line 43 "../src/contacts-avatar-utils.vala"
			_tmp26_ = cr;
#line 43 "../src/contacts-avatar-utils.vala"
			cairo_move_to (_tmp26_, (-(((gdouble) width) / PANGO_SCALE)) / 2, (-(((gdouble) height) / PANGO_SCALE)) / 2);
#line 47 "../src/contacts-avatar-utils.vala"
			_tmp27_ = cr;
#line 47 "../src/contacts-avatar-utils.vala"
			_tmp28_ = layout;
#line 47 "../src/contacts-avatar-utils.vala"
			pango_cairo_show_layout (_tmp27_, _tmp28_);
#line 32 "../src/contacts-avatar-utils.vala"
			_g_object_unref0 (layout);
#line 32 "../src/contacts-avatar-utils.vala"
			_g_free0 (font);
#line 207 "contacts-avatar-utils.c"
		}
#line 30 "../src/contacts-avatar-utils.vala"
		_g_free0 (initials);
#line 211 "contacts-avatar-utils.c"
	} else {
		{
			GtkIconTheme* theme = NULL;
			GtkIconTheme* _tmp29_;
			GtkIconTheme* _tmp30_;
			GtkIconInfo* fallback_avatar = NULL;
			GtkIconTheme* _tmp31_;
			GtkIconInfo* _tmp32_;
			GdkRGBA fg_color = {0};
			GdkRGBA _tmp33_ = {0};
			GdkPixbuf* icon_pixbuf = NULL;
			GtkIconInfo* _tmp34_;
			GdkRGBA _tmp35_;
			GdkPixbuf* _tmp36_;
			gdouble x = 0.0;
			GdkPixbuf* _tmp37_;
			gint _tmp38_;
			gint _tmp39_;
			gdouble y = 0.0;
			GdkPixbuf* _tmp40_;
			gint _tmp41_;
			gint _tmp42_;
			cairo_t* _tmp43_;
			GdkPixbuf* _tmp44_;
			cairo_t* _tmp45_;
#line 51 "../src/contacts-avatar-utils.vala"
			_tmp29_ = gtk_icon_theme_get_default ();
#line 51 "../src/contacts-avatar-utils.vala"
			_tmp30_ = _g_object_ref0 (_tmp29_);
#line 51 "../src/contacts-avatar-utils.vala"
			theme = _tmp30_;
#line 52 "../src/contacts-avatar-utils.vala"
			_tmp31_ = theme;
#line 52 "../src/contacts-avatar-utils.vala"
			_tmp32_ = gtk_icon_theme_lookup_icon (_tmp31_, "avatar-default", (size * 1) / 2, GTK_ICON_LOOKUP_FORCE_SYMBOLIC);
#line 52 "../src/contacts-avatar-utils.vala"
			fallback_avatar = _tmp32_;
#line 55 "../src/contacts-avatar-utils.vala"
			_tmp33_.red = (gdouble) 1;
#line 55 "../src/contacts-avatar-utils.vala"
			_tmp33_.green = (gdouble) 1;
#line 55 "../src/contacts-avatar-utils.vala"
			_tmp33_.blue = (gdouble) 1;
#line 55 "../src/contacts-avatar-utils.vala"
			_tmp33_.alpha = (gdouble) 1;
#line 55 "../src/contacts-avatar-utils.vala"
			fg_color = _tmp33_;
#line 56 "../src/contacts-avatar-utils.vala"
			_tmp34_ = fallback_avatar;
#line 56 "../src/contacts-avatar-utils.vala"
			_tmp35_ = fg_color;
#line 56 "../src/contacts-avatar-utils.vala"
			_tmp36_ = gtk_icon_info_load_symbolic (_tmp34_, &_tmp35_, NULL, NULL, NULL, NULL, &_inner_error0_);
#line 56 "../src/contacts-avatar-utils.vala"
			icon_pixbuf = _tmp36_;
#line 56 "../src/contacts-avatar-utils.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 56 "../src/contacts-avatar-utils.vala"
				_g_object_unref0 (fallback_avatar);
#line 56 "../src/contacts-avatar-utils.vala"
				_g_object_unref0 (theme);
#line 273 "contacts-avatar-utils.c"
				goto __catch11_g_error;
			}
#line 57 "../src/contacts-avatar-utils.vala"
			_tmp37_ = icon_pixbuf;
#line 57 "../src/contacts-avatar-utils.vala"
			_tmp38_ = gdk_pixbuf_get_width (_tmp37_);
#line 57 "../src/contacts-avatar-utils.vala"
			_tmp39_ = _tmp38_;
#line 57 "../src/contacts-avatar-utils.vala"
			x = (((gdouble) size) / 2.0) - (((gdouble) _tmp39_) / 2.0);
#line 59 "../src/contacts-avatar-utils.vala"
			_tmp40_ = icon_pixbuf;
#line 59 "../src/contacts-avatar-utils.vala"
			_tmp41_ = gdk_pixbuf_get_height (_tmp40_);
#line 59 "../src/contacts-avatar-utils.vala"
			_tmp42_ = _tmp41_;
#line 59 "../src/contacts-avatar-utils.vala"
			y = ((((gdouble) size) / 2.0) - (((gdouble) _tmp42_) / 2.0)) - ((2 * size) / 100.0);
#line 60 "../src/contacts-avatar-utils.vala"
			_tmp43_ = cr;
#line 60 "../src/contacts-avatar-utils.vala"
			_tmp44_ = icon_pixbuf;
#line 60 "../src/contacts-avatar-utils.vala"
			gdk_cairo_set_source_pixbuf (_tmp43_, _tmp44_, x, y);
#line 61 "../src/contacts-avatar-utils.vala"
			_tmp45_ = cr;
#line 61 "../src/contacts-avatar-utils.vala"
			cairo_paint (_tmp45_);
#line 50 "../src/contacts-avatar-utils.vala"
			_g_object_unref0 (icon_pixbuf);
#line 50 "../src/contacts-avatar-utils.vala"
			_g_object_unref0 (fallback_avatar);
#line 50 "../src/contacts-avatar-utils.vala"
			_g_object_unref0 (theme);
#line 308 "contacts-avatar-utils.c"
		}
		goto __finally11;
		__catch11_g_error:
		{
			GError* e = NULL;
			GError* _tmp46_;
			const gchar* _tmp47_;
#line 50 "../src/contacts-avatar-utils.vala"
			e = _inner_error0_;
#line 50 "../src/contacts-avatar-utils.vala"
			_inner_error0_ = NULL;
#line 63 "../src/contacts-avatar-utils.vala"
			_tmp46_ = e;
#line 63 "../src/contacts-avatar-utils.vala"
			_tmp47_ = _tmp46_->message;
#line 63 "../src/contacts-avatar-utils.vala"
			g_warning ("contacts-avatar-utils.vala:63: Couldn't get default avatar icon: %s", _tmp47_);
#line 50 "../src/contacts-avatar-utils.vala"
			_g_error_free0 (e);
#line 328 "contacts-avatar-utils.c"
		}
		__finally11:
#line 50 "../src/contacts-avatar-utils.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 50 "../src/contacts-avatar-utils.vala"
			_cairo_destroy0 (cr);
#line 50 "../src/contacts-avatar-utils.vala"
			_cairo_surface_destroy0 (surface);
#line 50 "../src/contacts-avatar-utils.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 50 "../src/contacts-avatar-utils.vala"
			g_clear_error (&_inner_error0_);
#line 50 "../src/contacts-avatar-utils.vala"
			return NULL;
#line 343 "contacts-avatar-utils.c"
		}
	}
#line 67 "../src/contacts-avatar-utils.vala"
	_tmp48_ = surface;
#line 67 "../src/contacts-avatar-utils.vala"
	_tmp49_ = gdk_pixbuf_get_from_surface (_tmp48_, 0, 0, size, size);
#line 67 "../src/contacts-avatar-utils.vala"
	result = _tmp49_;
#line 67 "../src/contacts-avatar-utils.vala"
	_cairo_destroy0 (cr);
#line 67 "../src/contacts-avatar-utils.vala"
	_cairo_surface_destroy0 (surface);
#line 67 "../src/contacts-avatar-utils.vala"
	return result;
#line 358 "contacts-avatar-utils.c"
}

GdkPixbuf*
contacts_avatar_utils_round_image (GdkPixbuf* source)
{
	GdkPixbuf* result = NULL;
	gint size = 0;
	gint _tmp0_;
	gint _tmp1_;
	cairo_surface_t* surface = NULL;
	cairo_surface_t* _tmp2_;
	cairo_t* cr = NULL;
	cairo_t* _tmp3_;
	GdkPixbuf* _tmp4_;
#line 72 "../src/contacts-avatar-utils.vala"
	g_return_val_if_fail (source != NULL, NULL);
#line 73 "../src/contacts-avatar-utils.vala"
	_tmp0_ = gdk_pixbuf_get_width (source);
#line 73 "../src/contacts-avatar-utils.vala"
	_tmp1_ = _tmp0_;
#line 73 "../src/contacts-avatar-utils.vala"
	size = _tmp1_;
#line 74 "../src/contacts-avatar-utils.vala"
	_tmp2_ = cairo_image_surface_create (CAIRO_FORMAT_ARGB32, size, size);
#line 74 "../src/contacts-avatar-utils.vala"
	surface = _tmp2_;
#line 77 "../src/contacts-avatar-utils.vala"
	_tmp3_ = cairo_create (surface);
#line 77 "../src/contacts-avatar-utils.vala"
	cr = _tmp3_;
#line 80 "../src/contacts-avatar-utils.vala"
	cairo_arc (cr, (gdouble) (size / 2), (gdouble) (size / 2), (gdouble) (size / 2), (gdouble) 0, 2 * G_PI);
#line 81 "../src/contacts-avatar-utils.vala"
	cairo_clip (cr);
#line 82 "../src/contacts-avatar-utils.vala"
	cairo_new_path (cr);
#line 84 "../src/contacts-avatar-utils.vala"
	gdk_cairo_set_source_pixbuf (cr, source, (gdouble) 0, (gdouble) 0);
#line 85 "../src/contacts-avatar-utils.vala"
	cairo_paint (cr);
#line 87 "../src/contacts-avatar-utils.vala"
	_tmp4_ = gdk_pixbuf_get_from_surface (surface, 0, 0, size, size);
#line 87 "../src/contacts-avatar-utils.vala"
	result = _tmp4_;
#line 87 "../src/contacts-avatar-utils.vala"
	_cairo_destroy0 (cr);
#line 87 "../src/contacts-avatar-utils.vala"
	_cairo_surface_destroy0 (surface);
#line 87 "../src/contacts-avatar-utils.vala"
	return result;
#line 409 "contacts-avatar-utils.c"
}

static gchar*
string_strip (const gchar* self)
{
	gchar* result = NULL;
	gchar* _result_ = NULL;
	gchar* _tmp0_;
	const gchar* _tmp1_;
#line 1307 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1308 "glib-2.0.vapi"
	_tmp0_ = g_strdup (self);
#line 1308 "glib-2.0.vapi"
	_result_ = _tmp0_;
#line 1309 "glib-2.0.vapi"
	_tmp1_ = _result_;
#line 1309 "glib-2.0.vapi"
	g_strstrip (_tmp1_);
#line 1310 "glib-2.0.vapi"
	result = _result_;
#line 1310 "glib-2.0.vapi"
	return result;
#line 433 "contacts-avatar-utils.c"
}

static gboolean
string_get_next_char (const gchar* self,
                      gint* index,
                      gunichar* c)
{
	gunichar _vala_c = 0U;
	gboolean result = FALSE;
#line 1199 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, FALSE);
#line 1200 "glib-2.0.vapi"
	_vala_c = g_utf8_get_char (((gchar*) self) + (*index));
#line 1201 "glib-2.0.vapi"
	if (_vala_c != ((gunichar) 0)) {
#line 449 "contacts-avatar-utils.c"
		gchar* _tmp0_;
#line 1202 "glib-2.0.vapi"
		_tmp0_ = g_utf8_next_char (((gchar*) self) + (*index));
#line 1202 "glib-2.0.vapi"
		*index = (gint) (_tmp0_ - ((gchar*) self));
#line 1203 "glib-2.0.vapi"
		result = TRUE;
#line 1203 "glib-2.0.vapi"
		if (c) {
#line 1203 "glib-2.0.vapi"
			*c = _vala_c;
#line 461 "contacts-avatar-utils.c"
		}
#line 1203 "glib-2.0.vapi"
		return result;
#line 465 "contacts-avatar-utils.c"
	} else {
#line 1205 "glib-2.0.vapi"
		result = FALSE;
#line 1205 "glib-2.0.vapi"
		if (c) {
#line 1205 "glib-2.0.vapi"
			*c = _vala_c;
#line 473 "contacts-avatar-utils.c"
		}
#line 1205 "glib-2.0.vapi"
		return result;
#line 477 "contacts-avatar-utils.c"
	}
#line 1199 "glib-2.0.vapi"
	if (c) {
#line 1199 "glib-2.0.vapi"
		*c = _vala_c;
#line 483 "contacts-avatar-utils.c"
	}
}

static gint
string_last_index_of_char (const gchar* self,
                           gunichar c,
                           gint start_index)
{
	gint result = 0;
	gchar* _result_ = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
#line 1111 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, 0);
#line 1112 "glib-2.0.vapi"
	_tmp0_ = g_utf8_strrchr (((gchar*) self) + start_index, (gssize) -1, c);
#line 1112 "glib-2.0.vapi"
	_result_ = _tmp0_;
#line 1114 "glib-2.0.vapi"
	_tmp1_ = _result_;
#line 1114 "glib-2.0.vapi"
	if (_tmp1_ != NULL) {
#line 506 "contacts-avatar-utils.c"
		gchar* _tmp2_;
#line 1115 "glib-2.0.vapi"
		_tmp2_ = _result_;
#line 1115 "glib-2.0.vapi"
		result = (gint) (_tmp2_ - ((gchar*) self));
#line 1115 "glib-2.0.vapi"
		return result;
#line 514 "contacts-avatar-utils.c"
	} else {
#line 1117 "glib-2.0.vapi"
		result = -1;
#line 1117 "glib-2.0.vapi"
		return result;
#line 520 "contacts-avatar-utils.c"
	}
}

static guint8*
g_string_get_data (GString* self,
                   gint* result_length1)
{
	guint8* result;
	guint8* res = NULL;
	const gchar* _tmp0_;
	gint res_length1;
	gint _res_size_;
	guint8* _tmp1_;
	gint _tmp1__length1;
	guint8* _tmp2_;
	gint _tmp2__length1;
#line 5028 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 5029 "glib-2.0.vapi"
	_tmp0_ = self->str;
#line 5029 "glib-2.0.vapi"
	res = (guint8*) _tmp0_;
#line 5029 "glib-2.0.vapi"
	res_length1 = -1;
#line 5029 "glib-2.0.vapi"
	_res_size_ = res_length1;
#line 5030 "glib-2.0.vapi"
	res_length1 = (gint) self->len;
#line 5031 "glib-2.0.vapi"
	_tmp1_ = res;
#line 5031 "glib-2.0.vapi"
	_tmp1__length1 = res_length1;
#line 5031 "glib-2.0.vapi"
	_tmp2_ = _tmp1_;
#line 5031 "glib-2.0.vapi"
	_tmp2__length1 = _tmp1__length1;
#line 5031 "glib-2.0.vapi"
	if (result_length1) {
#line 5031 "glib-2.0.vapi"
		*result_length1 = _tmp2__length1;
#line 561 "contacts-avatar-utils.c"
	}
#line 5031 "glib-2.0.vapi"
	result = _tmp2_;
#line 5031 "glib-2.0.vapi"
	return result;
#line 567 "contacts-avatar-utils.c"
}

gchar*
contacts_avatar_utils_extract_initials_from_name (const gchar* name)
{
	gchar* result = NULL;
	gchar* normalized = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	gchar* _tmp5_;
	gchar* initials = NULL;
	const gchar* _tmp6_;
#line 92 "../src/contacts-avatar-utils.vala"
	g_return_val_if_fail (name != NULL, NULL);
#line 93 "../src/contacts-avatar-utils.vala"
	_tmp0_ = string_strip (name);
#line 93 "../src/contacts-avatar-utils.vala"
	_tmp1_ = _tmp0_;
#line 93 "../src/contacts-avatar-utils.vala"
	_tmp2_ = g_utf8_strup (_tmp1_, (gssize) -1);
#line 93 "../src/contacts-avatar-utils.vala"
	_tmp3_ = _tmp2_;
#line 93 "../src/contacts-avatar-utils.vala"
	_tmp4_ = g_utf8_normalize (_tmp3_, (gssize) -1, G_NORMALIZE_DEFAULT);
#line 93 "../src/contacts-avatar-utils.vala"
	_tmp5_ = _tmp4_;
#line 93 "../src/contacts-avatar-utils.vala"
	_g_free0 (_tmp3_);
#line 93 "../src/contacts-avatar-utils.vala"
	_g_free0 (_tmp1_);
#line 93 "../src/contacts-avatar-utils.vala"
	normalized = _tmp5_;
#line 94 "../src/contacts-avatar-utils.vala"
	initials = NULL;
#line 95 "../src/contacts-avatar-utils.vala"
	_tmp6_ = normalized;
#line 95 "../src/contacts-avatar-utils.vala"
	if (g_strcmp0 (_tmp6_, "") != 0) {
#line 609 "contacts-avatar-utils.c"
		GString* buf = NULL;
		GString* _tmp7_;
		gunichar c = 0U;
		gint index = 0;
		const gchar* _tmp14_;
		GString* _tmp21_;
		guint8* _tmp22_;
		gint _tmp22__length1;
		guint8* _tmp23_;
		gint _tmp23__length1;
#line 96 "../src/contacts-avatar-utils.vala"
		_tmp7_ = g_string_new ("");
#line 96 "../src/contacts-avatar-utils.vala"
		buf = _tmp7_;
#line 97 "../src/contacts-avatar-utils.vala"
		c = (gunichar) 0;
#line 98 "../src/contacts-avatar-utils.vala"
		index = 0;
#line 628 "contacts-avatar-utils.c"
		{
			gint i = 0;
#line 101 "../src/contacts-avatar-utils.vala"
			i = 0;
#line 633 "contacts-avatar-utils.c"
			{
				gboolean _tmp8_ = FALSE;
#line 101 "../src/contacts-avatar-utils.vala"
				_tmp8_ = TRUE;
#line 101 "../src/contacts-avatar-utils.vala"
				while (TRUE) {
#line 640 "contacts-avatar-utils.c"
					const gchar* _tmp10_;
					gunichar _tmp11_ = 0U;
					gboolean _tmp12_;
#line 101 "../src/contacts-avatar-utils.vala"
					if (!_tmp8_) {
#line 646 "contacts-avatar-utils.c"
						gint _tmp9_;
#line 101 "../src/contacts-avatar-utils.vala"
						_tmp9_ = i;
#line 101 "../src/contacts-avatar-utils.vala"
						i = _tmp9_ + 1;
#line 652 "contacts-avatar-utils.c"
					}
#line 101 "../src/contacts-avatar-utils.vala"
					_tmp8_ = FALSE;
#line 101 "../src/contacts-avatar-utils.vala"
					_tmp10_ = normalized;
#line 101 "../src/contacts-avatar-utils.vala"
					_tmp12_ = string_get_next_char (_tmp10_, &index, &_tmp11_);
#line 101 "../src/contacts-avatar-utils.vala"
					c = _tmp11_;
#line 101 "../src/contacts-avatar-utils.vala"
					if (!_tmp12_) {
#line 101 "../src/contacts-avatar-utils.vala"
						break;
#line 666 "contacts-avatar-utils.c"
					}
#line 102 "../src/contacts-avatar-utils.vala"
					if (g_unichar_isalnum (c)) {
#line 670 "contacts-avatar-utils.c"
						GString* _tmp13_;
#line 103 "../src/contacts-avatar-utils.vala"
						_tmp13_ = buf;
#line 103 "../src/contacts-avatar-utils.vala"
						g_string_append_unichar (_tmp13_, c);
#line 104 "../src/contacts-avatar-utils.vala"
						break;
#line 678 "contacts-avatar-utils.c"
					}
				}
			}
		}
#line 109 "../src/contacts-avatar-utils.vala"
		_tmp14_ = normalized;
#line 109 "../src/contacts-avatar-utils.vala"
		index = string_last_index_of_char (_tmp14_, (gunichar) ' ', 0);
#line 110 "../src/contacts-avatar-utils.vala"
		if (index >= 0) {
#line 689 "contacts-avatar-utils.c"
			{
				gint i = 0;
#line 111 "../src/contacts-avatar-utils.vala"
				i = 0;
#line 694 "contacts-avatar-utils.c"
				{
					gboolean _tmp15_ = FALSE;
#line 111 "../src/contacts-avatar-utils.vala"
					_tmp15_ = TRUE;
#line 111 "../src/contacts-avatar-utils.vala"
					while (TRUE) {
#line 701 "contacts-avatar-utils.c"
						const gchar* _tmp17_;
						gunichar _tmp18_ = 0U;
						gboolean _tmp19_;
#line 111 "../src/contacts-avatar-utils.vala"
						if (!_tmp15_) {
#line 707 "contacts-avatar-utils.c"
							gint _tmp16_;
#line 111 "../src/contacts-avatar-utils.vala"
							_tmp16_ = i;
#line 111 "../src/contacts-avatar-utils.vala"
							i = _tmp16_ + 1;
#line 713 "contacts-avatar-utils.c"
						}
#line 111 "../src/contacts-avatar-utils.vala"
						_tmp15_ = FALSE;
#line 111 "../src/contacts-avatar-utils.vala"
						_tmp17_ = normalized;
#line 111 "../src/contacts-avatar-utils.vala"
						_tmp19_ = string_get_next_char (_tmp17_, &index, &_tmp18_);
#line 111 "../src/contacts-avatar-utils.vala"
						c = _tmp18_;
#line 111 "../src/contacts-avatar-utils.vala"
						if (!_tmp19_) {
#line 111 "../src/contacts-avatar-utils.vala"
							break;
#line 727 "contacts-avatar-utils.c"
						}
#line 112 "../src/contacts-avatar-utils.vala"
						if (g_unichar_isalnum (c)) {
#line 731 "contacts-avatar-utils.c"
							GString* _tmp20_;
#line 113 "../src/contacts-avatar-utils.vala"
							_tmp20_ = buf;
#line 113 "../src/contacts-avatar-utils.vala"
							g_string_append_unichar (_tmp20_, c);
#line 114 "../src/contacts-avatar-utils.vala"
							break;
#line 739 "contacts-avatar-utils.c"
						}
					}
				}
			}
		}
#line 119 "../src/contacts-avatar-utils.vala"
		_tmp21_ = buf;
#line 119 "../src/contacts-avatar-utils.vala"
		_tmp22_ = g_string_get_data (_tmp21_, &_tmp22__length1);
#line 119 "../src/contacts-avatar-utils.vala"
		_tmp23_ = _tmp22_;
#line 119 "../src/contacts-avatar-utils.vala"
		_tmp23__length1 = _tmp22__length1;
#line 119 "../src/contacts-avatar-utils.vala"
		if (_tmp23__length1 > 0) {
#line 755 "contacts-avatar-utils.c"
			GString* _tmp24_;
			guint8* _tmp25_;
			gint _tmp25__length1;
			guint8* _tmp26_;
			gint _tmp26__length1;
			gchar* _tmp27_;
#line 120 "../src/contacts-avatar-utils.vala"
			_tmp24_ = buf;
#line 120 "../src/contacts-avatar-utils.vala"
			_tmp25_ = g_string_get_data (_tmp24_, &_tmp25__length1);
#line 120 "../src/contacts-avatar-utils.vala"
			_tmp26_ = _tmp25_;
#line 120 "../src/contacts-avatar-utils.vala"
			_tmp26__length1 = _tmp25__length1;
#line 120 "../src/contacts-avatar-utils.vala"
			_tmp27_ = g_strdup ((const gchar*) _tmp26_);
#line 120 "../src/contacts-avatar-utils.vala"
			_g_free0 (initials);
#line 120 "../src/contacts-avatar-utils.vala"
			initials = _tmp27_;
#line 776 "contacts-avatar-utils.c"
		}
#line 95 "../src/contacts-avatar-utils.vala"
		_g_string_free0 (buf);
#line 780 "contacts-avatar-utils.c"
	}
#line 123 "../src/contacts-avatar-utils.vala"
	result = initials;
#line 123 "../src/contacts-avatar-utils.vala"
	_g_free0 (normalized);
#line 123 "../src/contacts-avatar-utils.vala"
	return result;
#line 788 "contacts-avatar-utils.c"
}

void
contacts_avatar_utils_get_color_for_name (const gchar* name,
                                          GdkRGBA* result)
{
#line 129 "../src/contacts-avatar-utils.vala"
	static const gdouble GNOME_COLOR_PALETTE[28][3] = {{(gdouble) 98, (gdouble) 160, (gdouble) 234}, {(gdouble) 53, (gdouble) 132, (gdouble) 228}, {(gdouble) 28, (gdouble) 113, (gdouble) 216}, {(gdouble) 26, (gdouble) 95, (gdouble) 180}, {(gdouble) 87, (gdouble) 227, (gdouble) 137}, {(gdouble) 51, (gdouble) 209, (gdouble) 122}, {(gdouble) 46, (gdouble) 194, (gdouble) 126}, {(gdouble) 38, (gdouble) 162, (gdouble) 105}, {(gdouble) 248, (gdouble) 228, (gdouble) 92}, {(gdouble) 246, (gdouble) 211, (gdouble) 45}, {(gdouble) 245, (gdouble) 194, (gdouble) 17}, {(gdouble) 229, (gdouble) 165, (gdouble) 10}, {(gdouble) 255, (gdouble) 163, (gdouble) 72}, {(gdouble) 255, (gdouble) 120, (gdouble) 0}, {(gdouble) 230, (gdouble) 97, (gdouble) 0}, {(gdouble) 198, (gdouble) 70, (gdouble) 0}, {(gdouble) 237, (gdouble) 51, (gdouble) 59}, {(gdouble) 224, (gdouble) 27, (gdouble) 36}, {(gdouble) 192, (gdouble) 28, (gdouble) 40}, {(gdouble) 165, (gdouble) 29, (gdouble) 45}, {(gdouble) 192, (gdouble) 97, (gdouble) 203}, {(gdouble) 163, (gdouble) 71, (gdouble) 186}, {(gdouble) 129, (gdouble) 61, (gdouble) 156}, {(gdouble) 97, (gdouble) 53, (gdouble) 131}, {(gdouble) 181, (gdouble) 131, (gdouble) 90}, {(gdouble) 152, (gdouble) 106, (gdouble) 68}, {(gdouble) 134, (gdouble) 94, (gdouble) 60}, {(gdouble) 99, (gdouble) 69, (gdouble) 44}};
#line 797 "contacts-avatar-utils.c"
	GdkRGBA color = {0};
	GdkRGBA _tmp0_ = {0};
	guint hash = 0U;
	guint number_of_colors = 0U;
	gint _tmp1_;
	guint idx = 0U;
	gdouble _tmp5_;
	gdouble _tmp6_;
	gdouble _tmp7_;
#line 127 "../src/contacts-avatar-utils.vala"
	g_return_if_fail (name != NULL);
#line 160 "../src/contacts-avatar-utils.vala"
	_tmp0_.red = (gdouble) 255;
#line 160 "../src/contacts-avatar-utils.vala"
	_tmp0_.green = (gdouble) 255;
#line 160 "../src/contacts-avatar-utils.vala"
	_tmp0_.blue = (gdouble) 255;
#line 160 "../src/contacts-avatar-utils.vala"
	_tmp0_.alpha = 1.0;
#line 160 "../src/contacts-avatar-utils.vala"
	color = _tmp0_;
#line 162 "../src/contacts-avatar-utils.vala"
	_tmp1_ = G_N_ELEMENTS (GNOME_COLOR_PALETTE);
#line 162 "../src/contacts-avatar-utils.vala"
	number_of_colors = (guint) _tmp1_;
#line 165 "../src/contacts-avatar-utils.vala"
	if (g_strcmp0 (name, "") == 0) {
#line 825 "contacts-avatar-utils.c"
		gdouble _tmp2_;
		gdouble _tmp3_;
		gdouble _tmp4_;
#line 167 "../src/contacts-avatar-utils.vala"
		idx = (guint) g_random_int_range ((gint32) 0, (gint32) number_of_colors);
#line 168 "../src/contacts-avatar-utils.vala"
		_tmp2_ = (*GNOME_COLOR_PALETTE)[(idx * G_N_ELEMENTS (GNOME_COLOR_PALETTE[0])) + 0];
#line 168 "../src/contacts-avatar-utils.vala"
		color.red = _tmp2_;
#line 169 "../src/contacts-avatar-utils.vala"
		_tmp3_ = (*GNOME_COLOR_PALETTE)[(idx * G_N_ELEMENTS (GNOME_COLOR_PALETTE[0])) + 1];
#line 169 "../src/contacts-avatar-utils.vala"
		color.green = _tmp3_;
#line 170 "../src/contacts-avatar-utils.vala"
		_tmp4_ = (*GNOME_COLOR_PALETTE)[(idx * G_N_ELEMENTS (GNOME_COLOR_PALETTE[0])) + 2];
#line 170 "../src/contacts-avatar-utils.vala"
		color.blue = _tmp4_;
#line 171 "../src/contacts-avatar-utils.vala"
		*result = color;
#line 171 "../src/contacts-avatar-utils.vala"
		return;
#line 847 "contacts-avatar-utils.c"
	}
#line 174 "../src/contacts-avatar-utils.vala"
	hash = g_str_hash (name);
#line 175 "../src/contacts-avatar-utils.vala"
	idx = hash % number_of_colors;
#line 177 "../src/contacts-avatar-utils.vala"
	_tmp5_ = (*GNOME_COLOR_PALETTE)[(idx * G_N_ELEMENTS (GNOME_COLOR_PALETTE[0])) + 0];
#line 177 "../src/contacts-avatar-utils.vala"
	color.red = _tmp5_;
#line 178 "../src/contacts-avatar-utils.vala"
	_tmp6_ = (*GNOME_COLOR_PALETTE)[(idx * G_N_ELEMENTS (GNOME_COLOR_PALETTE[0])) + 1];
#line 178 "../src/contacts-avatar-utils.vala"
	color.green = _tmp6_;
#line 179 "../src/contacts-avatar-utils.vala"
	_tmp7_ = (*GNOME_COLOR_PALETTE)[(idx * G_N_ELEMENTS (GNOME_COLOR_PALETTE[0])) + 2];
#line 179 "../src/contacts-avatar-utils.vala"
	color.blue = _tmp7_;
#line 181 "../src/contacts-avatar-utils.vala"
	*result = color;
#line 181 "../src/contacts-avatar-utils.vala"
	return;
#line 869 "contacts-avatar-utils.c"
}

