/* contacts-avatar.c generated by valac 0.45.91, the Vala compiler
 * generated from contacts-avatar.vala, do not modify */

/*
 * Copyright (C) 2011 Alexander Larsson <alexl@redhat.com>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <gtk/gtk.h>
#include <glib-object.h>
#include <glib.h>
#include <gdk-pixbuf/gdk-pixbuf.h>
#include "contacts.h"
#include <cairo.h>
#include <gio/gio.h>
#include <folks/folks.h>
#include <gdk/gdk.h>
#include <float.h>
#include <math.h>
#include <stdlib.h>
#include <string.h>
#include <gee.h>

#define CONTACTS_TYPE_AVATAR (contacts_avatar_get_type ())
#define CONTACTS_AVATAR(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), CONTACTS_TYPE_AVATAR, ContactsAvatar))
#define CONTACTS_AVATAR_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), CONTACTS_TYPE_AVATAR, ContactsAvatarClass))
#define CONTACTS_IS_AVATAR(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), CONTACTS_TYPE_AVATAR))
#define CONTACTS_IS_AVATAR_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), CONTACTS_TYPE_AVATAR))
#define CONTACTS_AVATAR_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), CONTACTS_TYPE_AVATAR, ContactsAvatarClass))

typedef struct _ContactsAvatar ContactsAvatar;
typedef struct _ContactsAvatarClass ContactsAvatarClass;
typedef struct _ContactsAvatarPrivate ContactsAvatarPrivate;
enum  {
	CONTACTS_AVATAR_0_PROPERTY,
	CONTACTS_AVATAR_NUM_PROPERTIES
};
static GParamSpec* contacts_avatar_properties[CONTACTS_AVATAR_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
typedef struct _ContactsAvatarLoadAvatarData ContactsAvatarLoadAvatarData;
#define _g_free0(var) (var = (g_free (var), NULL))
#define _vala_assert(expr, msg) if G_LIKELY (expr) ; else g_assertion_message_expr (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);
#define _vala_return_if_fail(expr, msg) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return; }
#define _vala_return_val_if_fail(expr, msg, val) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return val; }
#define _vala_warn_if_fail(expr, msg) if G_LIKELY (expr) ; else g_warn_message (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);

struct _ContactsAvatar {
	GtkDrawingArea parent_instance;
	ContactsAvatarPrivate * priv;
};

struct _ContactsAvatarClass {
	GtkDrawingAreaClass parent_class;
};

struct _ContactsAvatarPrivate {
	gint size;
	GdkPixbuf* pixbuf;
	GdkPixbuf* cache;
	ContactsContact* contact;
	gboolean avatar_loaded;
};

struct _ContactsAvatarLoadAvatarData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	ContactsAvatar* self;
	ContactsContact* _tmp0_;
	GInputStream* stream;
	ContactsContact* _tmp1_;
	FolksIndividual* _tmp2_;
	GLoadableIcon* _tmp3_;
	GLoadableIcon* _tmp4_;
	GInputStream* _tmp5_;
	GdkPixbuf* _tmp6_;
	GInputStream* _tmp7_;
	GdkPixbuf* _tmp8_;
	GdkPixbuf* _tmp9_;
	GError* e;
	ContactsContact* _tmp10_;
	FolksIndividual* _tmp11_;
	const gchar* _tmp12_;
	const gchar* _tmp13_;
	GError* _tmp14_;
	const gchar* _tmp15_;
	GError* _inner_error0_;
};

static gint ContactsAvatar_private_offset;
static gpointer contacts_avatar_parent_class = NULL;

GType contacts_avatar_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (ContactsAvatar, g_object_unref)
ContactsAvatar* contacts_avatar_new (gint size,
                                     ContactsContact* contact);
ContactsAvatar* contacts_avatar_construct (GType object_type,
                                           gint size,
                                           ContactsContact* contact);
static void ___lambda5_ (ContactsAvatar* self,
                  GObject* s,
                  GParamSpec* p);
static void contacts_avatar_load_avatar (ContactsAvatar* self,
                                  GAsyncReadyCallback _callback_,
                                  gpointer _user_data_);
static void contacts_avatar_load_avatar_finish (ContactsAvatar* self,
                                         GAsyncResult* _res_);
static void ____lambda5__g_object_notify (GObject* _sender,
                                   GParamSpec* pspec,
                                   gpointer self);
void contacts_avatar_set_pixbuf (ContactsAvatar* self,
                                 GdkPixbuf* a_pixbuf);
static void contacts_avatar_load_avatar_data_free (gpointer _data);
static gboolean contacts_avatar_load_avatar_co (ContactsAvatarLoadAvatarData* _data_);
static void contacts_avatar_load_avatar_ready (GObject* source_object,
                                        GAsyncResult* _res_,
                                        gpointer _user_data_);
static gboolean contacts_avatar_real_draw (GtkWidget* base,
                                    cairo_t* cr);
static GdkPixbuf* contacts_avatar_create_contact_avatar (ContactsAvatar* self);
static GdkPixbuf* contacts_avatar_create_fallback (ContactsAvatar* self);
static void contacts_avatar_draw_cached_avatar (ContactsAvatar* self,
                                         cairo_t* cr);
static gchar* contacts_avatar_find_display_name (ContactsAvatar* self);
static gchar* contacts_avatar_look_up_alias_for_display_name (ContactsAvatar* self,
                                                       FolksPersona* p);
static gchar* contacts_avatar_look_up_name_details_for_display_name (ContactsAvatar* self,
                                                              FolksPersona* p);
static void contacts_avatar_finalize (GObject * obj);

static inline gpointer
contacts_avatar_get_instance_private (ContactsAvatar* self)
{
	return G_STRUCT_MEMBER_P (self, ContactsAvatar_private_offset);
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 37 "../src/contacts-avatar.vala"
	return self ? g_object_ref (self) : NULL;
#line 157 "contacts-avatar.c"
}

static void
___lambda5_ (ContactsAvatar* self,
             GObject* s,
             GParamSpec* p)
{
#line 39 "../src/contacts-avatar.vala"
	g_return_if_fail (s != NULL);
#line 39 "../src/contacts-avatar.vala"
	g_return_if_fail (p != NULL);
#line 40 "../src/contacts-avatar.vala"
	contacts_avatar_load_avatar (self, NULL, NULL);
#line 171 "contacts-avatar.c"
}

static void
____lambda5__g_object_notify (GObject* _sender,
                              GParamSpec* pspec,
                              gpointer self)
{
#line 39 "../src/contacts-avatar.vala"
	___lambda5_ ((ContactsAvatar*) self, _sender, pspec);
#line 181 "contacts-avatar.c"
}

ContactsAvatar*
contacts_avatar_construct (GType object_type,
                           gint size,
                           ContactsContact* contact)
{
	ContactsAvatar * self = NULL;
	ContactsContact* _tmp0_;
	gboolean _tmp2_ = FALSE;
#line 36 "../src/contacts-avatar.vala"
	self = (ContactsAvatar*) g_object_new (object_type, NULL);
#line 37 "../src/contacts-avatar.vala"
	_tmp0_ = _g_object_ref0 (contact);
#line 37 "../src/contacts-avatar.vala"
	_g_object_unref0 (self->priv->contact);
#line 37 "../src/contacts-avatar.vala"
	self->priv->contact = _tmp0_;
#line 38 "../src/contacts-avatar.vala"
	if (contact != NULL) {
#line 202 "contacts-avatar.c"
		FolksIndividual* _tmp1_;
#line 39 "../src/contacts-avatar.vala"
		_tmp1_ = contact->individual;
#line 39 "../src/contacts-avatar.vala"
		g_signal_connect_object ((GObject*) _tmp1_, "notify::avatar", (GCallback) ____lambda5__g_object_notify, self, 0);
#line 208 "contacts-avatar.c"
	}
#line 44 "../src/contacts-avatar.vala"
	self->priv->size = size;
#line 45 "../src/contacts-avatar.vala"
	gtk_widget_set_size_request ((GtkWidget*) self, size, size);
#line 48 "../src/contacts-avatar.vala"
	if (contact == NULL) {
#line 48 "../src/contacts-avatar.vala"
		_tmp2_ = TRUE;
#line 218 "contacts-avatar.c"
	} else {
		FolksIndividual* _tmp3_;
		GLoadableIcon* _tmp4_;
		GLoadableIcon* _tmp5_;
#line 48 "../src/contacts-avatar.vala"
		_tmp3_ = contact->individual;
#line 48 "../src/contacts-avatar.vala"
		_tmp4_ = folks_avatar_details_get_avatar ((FolksAvatarDetails*) _tmp3_);
#line 48 "../src/contacts-avatar.vala"
		_tmp5_ = _tmp4_;
#line 48 "../src/contacts-avatar.vala"
		_tmp2_ = _tmp5_ == NULL;
#line 231 "contacts-avatar.c"
	}
#line 48 "../src/contacts-avatar.vala"
	self->priv->avatar_loaded = _tmp2_;
#line 50 "../src/contacts-avatar.vala"
	gtk_widget_show ((GtkWidget*) self);
#line 36 "../src/contacts-avatar.vala"
	return self;
#line 239 "contacts-avatar.c"
}

ContactsAvatar*
contacts_avatar_new (gint size,
                     ContactsContact* contact)
{
#line 36 "../src/contacts-avatar.vala"
	return contacts_avatar_construct (CONTACTS_TYPE_AVATAR, size, contact);
#line 248 "contacts-avatar.c"
}

/**
   * Manually set the avatar to the given pixbuf, even if the contact has an avatar.
   */
void
contacts_avatar_set_pixbuf (ContactsAvatar* self,
                            GdkPixbuf* a_pixbuf)
{
	GdkPixbuf* _tmp0_;
#line 56 "../src/contacts-avatar.vala"
	g_return_if_fail (self != NULL);
#line 57 "../src/contacts-avatar.vala"
	_g_object_unref0 (self->priv->cache);
#line 57 "../src/contacts-avatar.vala"
	self->priv->cache = NULL;
#line 58 "../src/contacts-avatar.vala"
	_tmp0_ = _g_object_ref0 (a_pixbuf);
#line 58 "../src/contacts-avatar.vala"
	_g_object_unref0 (self->priv->pixbuf);
#line 58 "../src/contacts-avatar.vala"
	self->priv->pixbuf = _tmp0_;
#line 59 "../src/contacts-avatar.vala"
	gtk_widget_queue_draw ((GtkWidget*) self);
#line 273 "contacts-avatar.c"
}

static void
contacts_avatar_load_avatar_data_free (gpointer _data)
{
	ContactsAvatarLoadAvatarData* _data_;
	_data_ = _data;
#line 26 "../src/contacts-avatar.vala"
	_g_object_unref0 (_data_->self);
#line 26 "../src/contacts-avatar.vala"
	g_slice_free (ContactsAvatarLoadAvatarData, _data_);
#line 285 "contacts-avatar.c"
}

static void
contacts_avatar_load_avatar (ContactsAvatar* self,
                             GAsyncReadyCallback _callback_,
                             gpointer _user_data_)
{
	ContactsAvatarLoadAvatarData* _data_;
	ContactsAvatar* _tmp0_;
#line 26 "../src/contacts-avatar.vala"
	_data_ = g_slice_new0 (ContactsAvatarLoadAvatarData);
#line 26 "../src/contacts-avatar.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), NULL, _callback_, _user_data_);
#line 26 "../src/contacts-avatar.vala"
	g_task_set_task_data (_data_->_async_result, _data_, contacts_avatar_load_avatar_data_free);
#line 26 "../src/contacts-avatar.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 26 "../src/contacts-avatar.vala"
	_data_->self = _tmp0_;
#line 26 "../src/contacts-avatar.vala"
	contacts_avatar_load_avatar_co (_data_);
#line 307 "contacts-avatar.c"
}

static void
contacts_avatar_load_avatar_finish (ContactsAvatar* self,
                                    GAsyncResult* _res_)
{
	ContactsAvatarLoadAvatarData* _data_;
#line 26 "../src/contacts-avatar.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), NULL);
#line 317 "contacts-avatar.c"
}

static void
contacts_avatar_load_avatar_ready (GObject* source_object,
                                   GAsyncResult* _res_,
                                   gpointer _user_data_)
{
	ContactsAvatarLoadAvatarData* _data_;
#line 67 "../src/contacts-avatar.vala"
	_data_ = _user_data_;
#line 67 "../src/contacts-avatar.vala"
	_data_->_source_object_ = source_object;
#line 67 "../src/contacts-avatar.vala"
	_data_->_res_ = _res_;
#line 67 "../src/contacts-avatar.vala"
	contacts_avatar_load_avatar_co (_data_);
#line 334 "contacts-avatar.c"
}

static gboolean
contacts_avatar_load_avatar_co (ContactsAvatarLoadAvatarData* _data_)
{
#line 62 "../src/contacts-avatar.vala"
	switch (_data_->_state_) {
#line 62 "../src/contacts-avatar.vala"
		case 0:
#line 344 "contacts-avatar.c"
		goto _state_0;
#line 62 "../src/contacts-avatar.vala"
		case 1:
#line 348 "contacts-avatar.c"
		goto _state_1;
#line 62 "../src/contacts-avatar.vala"
		case 2:
#line 352 "contacts-avatar.c"
		goto _state_2;
		default:
#line 62 "../src/contacts-avatar.vala"
		g_assert_not_reached ();
#line 357 "contacts-avatar.c"
	}
	_state_0:
#line 63 "../src/contacts-avatar.vala"
	_data_->_tmp0_ = _data_->self->priv->contact;
#line 63 "../src/contacts-avatar.vala"
	_vala_assert (_data_->_tmp0_ != NULL, "this.contact != null");
#line 65 "../src/contacts-avatar.vala"
	_data_->self->priv->avatar_loaded = TRUE;
#line 366 "contacts-avatar.c"
	{
#line 67 "../src/contacts-avatar.vala"
		_data_->_tmp1_ = _data_->self->priv->contact;
#line 67 "../src/contacts-avatar.vala"
		_data_->_tmp2_ = _data_->_tmp1_->individual;
#line 67 "../src/contacts-avatar.vala"
		_data_->_tmp3_ = folks_avatar_details_get_avatar ((FolksAvatarDetails*) _data_->_tmp2_);
#line 67 "../src/contacts-avatar.vala"
		_data_->_tmp4_ = _data_->_tmp3_;
#line 67 "../src/contacts-avatar.vala"
		_data_->_state_ = 1;
#line 67 "../src/contacts-avatar.vala"
		g_loadable_icon_load_async (_data_->_tmp4_, _data_->self->priv->size, NULL, contacts_avatar_load_avatar_ready, _data_);
#line 67 "../src/contacts-avatar.vala"
		return FALSE;
#line 382 "contacts-avatar.c"
		_state_1:
#line 67 "../src/contacts-avatar.vala"
		_data_->_tmp5_ = g_loadable_icon_load_finish (_data_->_tmp4_, _data_->_res_, NULL, &_data_->_inner_error0_);
#line 67 "../src/contacts-avatar.vala"
		_data_->stream = _data_->_tmp5_;
#line 67 "../src/contacts-avatar.vala"
		if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 390 "contacts-avatar.c"
			goto __catch2_g_error;
		}
#line 68 "../src/contacts-avatar.vala"
		_g_object_unref0 (_data_->self->priv->cache);
#line 68 "../src/contacts-avatar.vala"
		_data_->self->priv->cache = NULL;
#line 69 "../src/contacts-avatar.vala"
		_data_->_tmp7_ = _data_->stream;
#line 69 "../src/contacts-avatar.vala"
		_data_->_state_ = 2;
#line 69 "../src/contacts-avatar.vala"
		gdk_pixbuf_new_from_stream_at_scale_async (_data_->_tmp7_, _data_->self->priv->size, _data_->self->priv->size, TRUE, NULL, contacts_avatar_load_avatar_ready, _data_);
#line 69 "../src/contacts-avatar.vala"
		return FALSE;
#line 405 "contacts-avatar.c"
		_state_2:
#line 69 "../src/contacts-avatar.vala"
		_data_->_tmp8_ = (GdkPixbuf*) gdk_pixbuf_new_from_stream_finish (_data_->_res_, &_data_->_inner_error0_);
#line 69 "../src/contacts-avatar.vala"
		_data_->_tmp6_ = _data_->_tmp8_;
#line 69 "../src/contacts-avatar.vala"
		if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 69 "../src/contacts-avatar.vala"
			_g_object_unref0 (_data_->stream);
#line 415 "contacts-avatar.c"
			goto __catch2_g_error;
		}
#line 69 "../src/contacts-avatar.vala"
		_data_->_tmp9_ = _data_->_tmp6_;
#line 69 "../src/contacts-avatar.vala"
		_data_->_tmp6_ = NULL;
#line 69 "../src/contacts-avatar.vala"
		_g_object_unref0 (_data_->self->priv->pixbuf);
#line 69 "../src/contacts-avatar.vala"
		_data_->self->priv->pixbuf = _data_->_tmp9_;
#line 70 "../src/contacts-avatar.vala"
		gtk_widget_queue_draw ((GtkWidget*) _data_->self);
#line 66 "../src/contacts-avatar.vala"
		_g_object_unref0 (_data_->_tmp6_);
#line 66 "../src/contacts-avatar.vala"
		_g_object_unref0 (_data_->stream);
#line 432 "contacts-avatar.c"
	}
	goto __finally2;
	__catch2_g_error:
	{
#line 66 "../src/contacts-avatar.vala"
		_data_->e = _data_->_inner_error0_;
#line 66 "../src/contacts-avatar.vala"
		_data_->_inner_error0_ = NULL;
#line 72 "../src/contacts-avatar.vala"
		_data_->_tmp10_ = _data_->self->priv->contact;
#line 72 "../src/contacts-avatar.vala"
		_data_->_tmp11_ = _data_->_tmp10_->individual;
#line 72 "../src/contacts-avatar.vala"
		_data_->_tmp12_ = folks_individual_get_display_name (_data_->_tmp11_);
#line 72 "../src/contacts-avatar.vala"
		_data_->_tmp13_ = _data_->_tmp12_;
#line 72 "../src/contacts-avatar.vala"
		_data_->_tmp14_ = _data_->e;
#line 72 "../src/contacts-avatar.vala"
		_data_->_tmp15_ = _data_->_tmp14_->message;
#line 72 "../src/contacts-avatar.vala"
		g_debug ("contacts-avatar.vala:72: Couldn't load avatar of contact %s. Reason: %" \
"s", _data_->_tmp13_, _data_->_tmp15_);
#line 66 "../src/contacts-avatar.vala"
		_g_error_free0 (_data_->e);
#line 457 "contacts-avatar.c"
	}
	__finally2:
#line 66 "../src/contacts-avatar.vala"
	if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 66 "../src/contacts-avatar.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _data_->_inner_error0_->message, g_quark_to_string (_data_->_inner_error0_->domain), _data_->_inner_error0_->code);
#line 66 "../src/contacts-avatar.vala"
		g_clear_error (&_data_->_inner_error0_);
#line 66 "../src/contacts-avatar.vala"
		g_object_unref (_data_->_async_result);
#line 66 "../src/contacts-avatar.vala"
		return FALSE;
#line 470 "contacts-avatar.c"
	}
#line 62 "../src/contacts-avatar.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 62 "../src/contacts-avatar.vala"
	if (_data_->_state_ != 0) {
#line 62 "../src/contacts-avatar.vala"
		while (!g_task_get_completed (_data_->_async_result)) {
#line 62 "../src/contacts-avatar.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 480 "contacts-avatar.c"
		}
	}
#line 62 "../src/contacts-avatar.vala"
	g_object_unref (_data_->_async_result);
#line 62 "../src/contacts-avatar.vala"
	return FALSE;
#line 487 "contacts-avatar.c"
}

static gboolean
contacts_avatar_real_draw (GtkWidget* base,
                           cairo_t* cr)
{
	ContactsAvatar * self;
	gboolean result = FALSE;
	GdkPixbuf* _tmp0_;
#line 76 "../src/contacts-avatar.vala"
	self = (ContactsAvatar*) base;
#line 76 "../src/contacts-avatar.vala"
	g_return_val_if_fail (cr != NULL, FALSE);
#line 78 "../src/contacts-avatar.vala"
	if (!self->priv->avatar_loaded) {
#line 79 "../src/contacts-avatar.vala"
		contacts_avatar_load_avatar (self, NULL, NULL);
#line 505 "contacts-avatar.c"
	}
#line 81 "../src/contacts-avatar.vala"
	_tmp0_ = self->priv->cache;
#line 81 "../src/contacts-avatar.vala"
	if (_tmp0_ != NULL) {
#line 511 "contacts-avatar.c"
	} else {
		GdkPixbuf* _tmp1_;
#line 83 "../src/contacts-avatar.vala"
		_tmp1_ = self->priv->pixbuf;
#line 83 "../src/contacts-avatar.vala"
		if (_tmp1_ != NULL) {
#line 518 "contacts-avatar.c"
			GdkPixbuf* _tmp2_;
#line 84 "../src/contacts-avatar.vala"
			_tmp2_ = contacts_avatar_create_contact_avatar (self);
#line 84 "../src/contacts-avatar.vala"
			_g_object_unref0 (self->priv->cache);
#line 84 "../src/contacts-avatar.vala"
			self->priv->cache = _tmp2_;
#line 526 "contacts-avatar.c"
		} else {
			GdkPixbuf* _tmp3_;
#line 86 "../src/contacts-avatar.vala"
			_tmp3_ = contacts_avatar_create_fallback (self);
#line 86 "../src/contacts-avatar.vala"
			_g_object_unref0 (self->priv->cache);
#line 86 "../src/contacts-avatar.vala"
			self->priv->cache = _tmp3_;
#line 535 "contacts-avatar.c"
		}
	}
#line 88 "../src/contacts-avatar.vala"
	contacts_avatar_draw_cached_avatar (self, cr);
#line 90 "../src/contacts-avatar.vala"
	result = TRUE;
#line 90 "../src/contacts-avatar.vala"
	return result;
#line 544 "contacts-avatar.c"
}

static void
contacts_avatar_draw_cached_avatar (ContactsAvatar* self,
                                    cairo_t* cr)
{
	GdkPixbuf* _tmp0_;
#line 93 "../src/contacts-avatar.vala"
	g_return_if_fail (self != NULL);
#line 93 "../src/contacts-avatar.vala"
	g_return_if_fail (cr != NULL);
#line 94 "../src/contacts-avatar.vala"
	_tmp0_ = self->priv->cache;
#line 94 "../src/contacts-avatar.vala"
	gdk_cairo_set_source_pixbuf (cr, _tmp0_, (gdouble) 0, (gdouble) 0);
#line 95 "../src/contacts-avatar.vala"
	cairo_paint (cr);
#line 562 "contacts-avatar.c"
}

static GdkPixbuf*
contacts_avatar_create_contact_avatar (ContactsAvatar* self)
{
	GdkPixbuf* result = NULL;
	GdkPixbuf* _tmp0_;
	GdkPixbuf* _tmp1_;
#line 98 "../src/contacts-avatar.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 99 "../src/contacts-avatar.vala"
	_tmp0_ = self->priv->pixbuf;
#line 99 "../src/contacts-avatar.vala"
	_tmp1_ = contacts_avatar_utils_round_image (_tmp0_);
#line 99 "../src/contacts-avatar.vala"
	result = _tmp1_;
#line 99 "../src/contacts-avatar.vala"
	return result;
#line 581 "contacts-avatar.c"
}

static GdkPixbuf*
contacts_avatar_create_fallback (ContactsAvatar* self)
{
	GdkPixbuf* result = NULL;
	gchar* name = NULL;
	gchar* _tmp0_;
	gboolean show_label = FALSE;
	gboolean _tmp1_ = FALSE;
	ContactsContact* _tmp2_;
	GdkPixbuf* pixbuf = NULL;
	const gchar* _tmp12_;
	GdkPixbuf* _tmp13_;
	GdkPixbuf* _tmp14_;
	GdkPixbuf* _tmp15_;
#line 102 "../src/contacts-avatar.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 103 "../src/contacts-avatar.vala"
	_tmp0_ = g_strdup ("");
#line 103 "../src/contacts-avatar.vala"
	name = _tmp0_;
#line 104 "../src/contacts-avatar.vala"
	show_label = FALSE;
#line 105 "../src/contacts-avatar.vala"
	_tmp2_ = self->priv->contact;
#line 105 "../src/contacts-avatar.vala"
	if (_tmp2_ != NULL) {
#line 610 "contacts-avatar.c"
		ContactsContact* _tmp3_;
		FolksIndividual* _tmp4_;
#line 105 "../src/contacts-avatar.vala"
		_tmp3_ = self->priv->contact;
#line 105 "../src/contacts-avatar.vala"
		_tmp4_ = _tmp3_->individual;
#line 105 "../src/contacts-avatar.vala"
		_tmp1_ = _tmp4_ != NULL;
#line 619 "contacts-avatar.c"
	} else {
#line 105 "../src/contacts-avatar.vala"
		_tmp1_ = FALSE;
#line 623 "contacts-avatar.c"
	}
#line 105 "../src/contacts-avatar.vala"
	if (_tmp1_) {
#line 627 "contacts-avatar.c"
		gchar* _tmp5_;
		const gchar* _tmp6_;
#line 106 "../src/contacts-avatar.vala"
		_tmp5_ = contacts_avatar_find_display_name (self);
#line 106 "../src/contacts-avatar.vala"
		_g_free0 (name);
#line 106 "../src/contacts-avatar.vala"
		name = _tmp5_;
#line 110 "../src/contacts-avatar.vala"
		_tmp6_ = name;
#line 110 "../src/contacts-avatar.vala"
		if (g_strcmp0 (_tmp6_, "") == 0) {
#line 640 "contacts-avatar.c"
			ContactsContact* _tmp7_;
			FolksIndividual* _tmp8_;
			const gchar* _tmp9_;
			const gchar* _tmp10_;
			gchar* _tmp11_;
#line 111 "../src/contacts-avatar.vala"
			_tmp7_ = self->priv->contact;
#line 111 "../src/contacts-avatar.vala"
			_tmp8_ = _tmp7_->individual;
#line 111 "../src/contacts-avatar.vala"
			_tmp9_ = folks_individual_get_display_name (_tmp8_);
#line 111 "../src/contacts-avatar.vala"
			_tmp10_ = _tmp9_;
#line 111 "../src/contacts-avatar.vala"
			_tmp11_ = g_strdup (_tmp10_);
#line 111 "../src/contacts-avatar.vala"
			_g_free0 (name);
#line 111 "../src/contacts-avatar.vala"
			name = _tmp11_;
#line 660 "contacts-avatar.c"
		} else {
#line 113 "../src/contacts-avatar.vala"
			show_label = TRUE;
#line 664 "contacts-avatar.c"
		}
	}
#line 116 "../src/contacts-avatar.vala"
	_tmp12_ = name;
#line 116 "../src/contacts-avatar.vala"
	_tmp13_ = contacts_avatar_utils_generate_user_picture (_tmp12_, self->priv->size, show_label);
#line 116 "../src/contacts-avatar.vala"
	pixbuf = _tmp13_;
#line 117 "../src/contacts-avatar.vala"
	_tmp14_ = pixbuf;
#line 117 "../src/contacts-avatar.vala"
	_tmp15_ = contacts_avatar_utils_round_image (_tmp14_);
#line 117 "../src/contacts-avatar.vala"
	_g_object_unref0 (pixbuf);
#line 117 "../src/contacts-avatar.vala"
	pixbuf = _tmp15_;
#line 119 "../src/contacts-avatar.vala"
	result = pixbuf;
#line 119 "../src/contacts-avatar.vala"
	_g_free0 (name);
#line 119 "../src/contacts-avatar.vala"
	return result;
#line 687 "contacts-avatar.c"
}

static gchar*
contacts_avatar_find_display_name (ContactsAvatar* self)
{
	gchar* result = NULL;
	gchar* name = NULL;
	gchar* _tmp0_;
	FolksPersona* primary_persona = NULL;
	FolksPersona* _tmp16_;
	gchar* _tmp17_;
	const gchar* _tmp18_;
	const gchar* _tmp29_;
#line 126 "../src/contacts-avatar.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 127 "../src/contacts-avatar.vala"
	_tmp0_ = g_strdup ("");
#line 127 "../src/contacts-avatar.vala"
	name = _tmp0_;
#line 128 "../src/contacts-avatar.vala"
	primary_persona = NULL;
#line 709 "contacts-avatar.c"
	{
		GeeIterator* _p_it = NULL;
		ContactsContact* _tmp1_;
		FolksIndividual* _tmp2_;
		GeeSet* _tmp3_;
		GeeSet* _tmp4_;
		GeeIterator* _tmp5_;
#line 129 "../src/contacts-avatar.vala"
		_tmp1_ = self->priv->contact;
#line 129 "../src/contacts-avatar.vala"
		_tmp2_ = _tmp1_->individual;
#line 129 "../src/contacts-avatar.vala"
		_tmp3_ = folks_individual_get_personas (_tmp2_);
#line 129 "../src/contacts-avatar.vala"
		_tmp4_ = _tmp3_;
#line 129 "../src/contacts-avatar.vala"
		_tmp5_ = gee_iterable_iterator ((GeeIterable*) _tmp4_);
#line 129 "../src/contacts-avatar.vala"
		_p_it = _tmp5_;
#line 129 "../src/contacts-avatar.vala"
		while (TRUE) {
#line 731 "contacts-avatar.c"
			GeeIterator* _tmp6_;
			FolksPersona* p = NULL;
			GeeIterator* _tmp7_;
			gpointer _tmp8_;
			FolksPersona* _tmp9_;
			FolksPersonaStore* _tmp10_;
			FolksPersonaStore* _tmp11_;
			gboolean _tmp12_;
			gboolean _tmp13_;
#line 129 "../src/contacts-avatar.vala"
			_tmp6_ = _p_it;
#line 129 "../src/contacts-avatar.vala"
			if (!gee_iterator_next (_tmp6_)) {
#line 129 "../src/contacts-avatar.vala"
				break;
#line 747 "contacts-avatar.c"
			}
#line 129 "../src/contacts-avatar.vala"
			_tmp7_ = _p_it;
#line 129 "../src/contacts-avatar.vala"
			_tmp8_ = gee_iterator_get (_tmp7_);
#line 129 "../src/contacts-avatar.vala"
			p = (FolksPersona*) _tmp8_;
#line 130 "../src/contacts-avatar.vala"
			_tmp9_ = p;
#line 130 "../src/contacts-avatar.vala"
			_tmp10_ = folks_persona_get_store (_tmp9_);
#line 130 "../src/contacts-avatar.vala"
			_tmp11_ = _tmp10_;
#line 130 "../src/contacts-avatar.vala"
			_tmp12_ = folks_persona_store_get_is_primary_store (_tmp11_);
#line 130 "../src/contacts-avatar.vala"
			_tmp13_ = _tmp12_;
#line 130 "../src/contacts-avatar.vala"
			if (_tmp13_) {
#line 767 "contacts-avatar.c"
				FolksPersona* _tmp14_;
				FolksPersona* _tmp15_;
#line 131 "../src/contacts-avatar.vala"
				_tmp14_ = p;
#line 131 "../src/contacts-avatar.vala"
				_tmp15_ = _g_object_ref0 (_tmp14_);
#line 131 "../src/contacts-avatar.vala"
				_g_object_unref0 (primary_persona);
#line 131 "../src/contacts-avatar.vala"
				primary_persona = _tmp15_;
#line 132 "../src/contacts-avatar.vala"
				_g_object_unref0 (p);
#line 132 "../src/contacts-avatar.vala"
				break;
#line 782 "contacts-avatar.c"
			}
#line 129 "../src/contacts-avatar.vala"
			_g_object_unref0 (p);
#line 786 "contacts-avatar.c"
		}
#line 129 "../src/contacts-avatar.vala"
		_g_object_unref0 (_p_it);
#line 790 "contacts-avatar.c"
	}
#line 135 "../src/contacts-avatar.vala"
	_tmp16_ = primary_persona;
#line 135 "../src/contacts-avatar.vala"
	_tmp17_ = contacts_avatar_look_up_alias_for_display_name (self, _tmp16_);
#line 135 "../src/contacts-avatar.vala"
	_g_free0 (name);
#line 135 "../src/contacts-avatar.vala"
	name = _tmp17_;
#line 136 "../src/contacts-avatar.vala"
	_tmp18_ = name;
#line 136 "../src/contacts-avatar.vala"
	if (g_strcmp0 (_tmp18_, "") == 0) {
#line 804 "contacts-avatar.c"
		{
			GeeIterator* _p_it = NULL;
			ContactsContact* _tmp19_;
			FolksIndividual* _tmp20_;
			GeeSet* _tmp21_;
			GeeSet* _tmp22_;
			GeeIterator* _tmp23_;
#line 137 "../src/contacts-avatar.vala"
			_tmp19_ = self->priv->contact;
#line 137 "../src/contacts-avatar.vala"
			_tmp20_ = _tmp19_->individual;
#line 137 "../src/contacts-avatar.vala"
			_tmp21_ = folks_individual_get_personas (_tmp20_);
#line 137 "../src/contacts-avatar.vala"
			_tmp22_ = _tmp21_;
#line 137 "../src/contacts-avatar.vala"
			_tmp23_ = gee_iterable_iterator ((GeeIterable*) _tmp22_);
#line 137 "../src/contacts-avatar.vala"
			_p_it = _tmp23_;
#line 137 "../src/contacts-avatar.vala"
			while (TRUE) {
#line 826 "contacts-avatar.c"
				GeeIterator* _tmp24_;
				FolksPersona* p = NULL;
				GeeIterator* _tmp25_;
				gpointer _tmp26_;
				FolksPersona* _tmp27_;
				gchar* _tmp28_;
#line 137 "../src/contacts-avatar.vala"
				_tmp24_ = _p_it;
#line 137 "../src/contacts-avatar.vala"
				if (!gee_iterator_next (_tmp24_)) {
#line 137 "../src/contacts-avatar.vala"
					break;
#line 839 "contacts-avatar.c"
				}
#line 137 "../src/contacts-avatar.vala"
				_tmp25_ = _p_it;
#line 137 "../src/contacts-avatar.vala"
				_tmp26_ = gee_iterator_get (_tmp25_);
#line 137 "../src/contacts-avatar.vala"
				p = (FolksPersona*) _tmp26_;
#line 138 "../src/contacts-avatar.vala"
				_tmp27_ = p;
#line 138 "../src/contacts-avatar.vala"
				_tmp28_ = contacts_avatar_look_up_alias_for_display_name (self, _tmp27_);
#line 138 "../src/contacts-avatar.vala"
				_g_free0 (name);
#line 138 "../src/contacts-avatar.vala"
				name = _tmp28_;
#line 137 "../src/contacts-avatar.vala"
				_g_object_unref0 (p);
#line 857 "contacts-avatar.c"
			}
#line 137 "../src/contacts-avatar.vala"
			_g_object_unref0 (_p_it);
#line 861 "contacts-avatar.c"
		}
	}
#line 141 "../src/contacts-avatar.vala"
	_tmp29_ = name;
#line 141 "../src/contacts-avatar.vala"
	if (g_strcmp0 (_tmp29_, "") == 0) {
#line 868 "contacts-avatar.c"
		{
			GeeIterator* _p_it = NULL;
			ContactsContact* _tmp30_;
			FolksIndividual* _tmp31_;
			GeeSet* _tmp32_;
			GeeSet* _tmp33_;
			GeeIterator* _tmp34_;
#line 142 "../src/contacts-avatar.vala"
			_tmp30_ = self->priv->contact;
#line 142 "../src/contacts-avatar.vala"
			_tmp31_ = _tmp30_->individual;
#line 142 "../src/contacts-avatar.vala"
			_tmp32_ = folks_individual_get_personas (_tmp31_);
#line 142 "../src/contacts-avatar.vala"
			_tmp33_ = _tmp32_;
#line 142 "../src/contacts-avatar.vala"
			_tmp34_ = gee_iterable_iterator ((GeeIterable*) _tmp33_);
#line 142 "../src/contacts-avatar.vala"
			_p_it = _tmp34_;
#line 142 "../src/contacts-avatar.vala"
			while (TRUE) {
#line 890 "contacts-avatar.c"
				GeeIterator* _tmp35_;
				FolksPersona* p = NULL;
				GeeIterator* _tmp36_;
				gpointer _tmp37_;
				FolksPersona* _tmp38_;
				gchar* _tmp39_;
#line 142 "../src/contacts-avatar.vala"
				_tmp35_ = _p_it;
#line 142 "../src/contacts-avatar.vala"
				if (!gee_iterator_next (_tmp35_)) {
#line 142 "../src/contacts-avatar.vala"
					break;
#line 903 "contacts-avatar.c"
				}
#line 142 "../src/contacts-avatar.vala"
				_tmp36_ = _p_it;
#line 142 "../src/contacts-avatar.vala"
				_tmp37_ = gee_iterator_get (_tmp36_);
#line 142 "../src/contacts-avatar.vala"
				p = (FolksPersona*) _tmp37_;
#line 143 "../src/contacts-avatar.vala"
				_tmp38_ = p;
#line 143 "../src/contacts-avatar.vala"
				_tmp39_ = contacts_avatar_look_up_name_details_for_display_name (self, _tmp38_);
#line 143 "../src/contacts-avatar.vala"
				_g_free0 (name);
#line 143 "../src/contacts-avatar.vala"
				name = _tmp39_;
#line 142 "../src/contacts-avatar.vala"
				_g_object_unref0 (p);
#line 921 "contacts-avatar.c"
			}
#line 142 "../src/contacts-avatar.vala"
			_g_object_unref0 (_p_it);
#line 925 "contacts-avatar.c"
		}
	}
#line 146 "../src/contacts-avatar.vala"
	result = name;
#line 146 "../src/contacts-avatar.vala"
	_g_object_unref0 (primary_persona);
#line 146 "../src/contacts-avatar.vala"
	return result;
#line 934 "contacts-avatar.c"
}

static gchar*
contacts_avatar_look_up_alias_for_display_name (ContactsAvatar* self,
                                                FolksPersona* p)
{
	gchar* result = NULL;
	FolksAliasDetails* a = NULL;
	FolksAliasDetails* _tmp0_;
	gboolean _tmp1_ = FALSE;
	FolksAliasDetails* _tmp2_;
	gchar* _tmp10_;
#line 149 "../src/contacts-avatar.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 150 "../src/contacts-avatar.vala"
	_tmp0_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_TYPE (p, FOLKS_TYPE_ALIAS_DETAILS) ? ((FolksAliasDetails*) p) : NULL);
#line 150 "../src/contacts-avatar.vala"
	a = _tmp0_;
#line 151 "../src/contacts-avatar.vala"
	_tmp2_ = a;
#line 151 "../src/contacts-avatar.vala"
	if (_tmp2_ != NULL) {
#line 957 "contacts-avatar.c"
		FolksAliasDetails* _tmp3_;
		const gchar* _tmp4_;
		const gchar* _tmp5_;
#line 151 "../src/contacts-avatar.vala"
		_tmp3_ = a;
#line 151 "../src/contacts-avatar.vala"
		_tmp4_ = folks_alias_details_get_alias (_tmp3_);
#line 151 "../src/contacts-avatar.vala"
		_tmp5_ = _tmp4_;
#line 151 "../src/contacts-avatar.vala"
		_tmp1_ = _tmp5_ != NULL;
#line 969 "contacts-avatar.c"
	} else {
#line 151 "../src/contacts-avatar.vala"
		_tmp1_ = FALSE;
#line 973 "contacts-avatar.c"
	}
#line 151 "../src/contacts-avatar.vala"
	if (_tmp1_) {
#line 977 "contacts-avatar.c"
		FolksAliasDetails* _tmp6_;
		const gchar* _tmp7_;
		const gchar* _tmp8_;
		gchar* _tmp9_;
#line 152 "../src/contacts-avatar.vala"
		_tmp6_ = a;
#line 152 "../src/contacts-avatar.vala"
		_tmp7_ = folks_alias_details_get_alias (_tmp6_);
#line 152 "../src/contacts-avatar.vala"
		_tmp8_ = _tmp7_;
#line 152 "../src/contacts-avatar.vala"
		_tmp9_ = g_strdup (_tmp8_);
#line 152 "../src/contacts-avatar.vala"
		result = _tmp9_;
#line 152 "../src/contacts-avatar.vala"
		_g_object_unref0 (a);
#line 152 "../src/contacts-avatar.vala"
		return result;
#line 996 "contacts-avatar.c"
	}
#line 154 "../src/contacts-avatar.vala"
	_tmp10_ = g_strdup ("");
#line 154 "../src/contacts-avatar.vala"
	result = _tmp10_;
#line 154 "../src/contacts-avatar.vala"
	_g_object_unref0 (a);
#line 154 "../src/contacts-avatar.vala"
	return result;
#line 1006 "contacts-avatar.c"
}

static gchar*
contacts_avatar_look_up_name_details_for_display_name (ContactsAvatar* self,
                                                       FolksPersona* p)
{
	gchar* result = NULL;
	FolksNameDetails* n = NULL;
	FolksNameDetails* _tmp0_;
	FolksNameDetails* _tmp1_;
	gchar* _tmp27_;
#line 157 "../src/contacts-avatar.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 158 "../src/contacts-avatar.vala"
	_tmp0_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_TYPE (p, FOLKS_TYPE_NAME_DETAILS) ? ((FolksNameDetails*) p) : NULL);
#line 158 "../src/contacts-avatar.vala"
	n = _tmp0_;
#line 159 "../src/contacts-avatar.vala"
	_tmp1_ = n;
#line 159 "../src/contacts-avatar.vala"
	if (_tmp1_ != NULL) {
#line 1028 "contacts-avatar.c"
		gboolean _tmp2_ = FALSE;
		FolksNameDetails* _tmp3_;
		const gchar* _tmp4_;
		const gchar* _tmp5_;
#line 160 "../src/contacts-avatar.vala"
		_tmp3_ = n;
#line 160 "../src/contacts-avatar.vala"
		_tmp4_ = folks_name_details_get_full_name (_tmp3_);
#line 160 "../src/contacts-avatar.vala"
		_tmp5_ = _tmp4_;
#line 160 "../src/contacts-avatar.vala"
		if (_tmp5_ != NULL) {
#line 1041 "contacts-avatar.c"
			FolksNameDetails* _tmp6_;
			const gchar* _tmp7_;
			const gchar* _tmp8_;
#line 160 "../src/contacts-avatar.vala"
			_tmp6_ = n;
#line 160 "../src/contacts-avatar.vala"
			_tmp7_ = folks_name_details_get_full_name (_tmp6_);
#line 160 "../src/contacts-avatar.vala"
			_tmp8_ = _tmp7_;
#line 160 "../src/contacts-avatar.vala"
			_tmp2_ = g_strcmp0 (_tmp8_, "") != 0;
#line 1053 "contacts-avatar.c"
		} else {
#line 160 "../src/contacts-avatar.vala"
			_tmp2_ = FALSE;
#line 1057 "contacts-avatar.c"
		}
#line 160 "../src/contacts-avatar.vala"
		if (_tmp2_) {
#line 1061 "contacts-avatar.c"
			FolksNameDetails* _tmp9_;
			const gchar* _tmp10_;
			const gchar* _tmp11_;
			gchar* _tmp12_;
#line 161 "../src/contacts-avatar.vala"
			_tmp9_ = n;
#line 161 "../src/contacts-avatar.vala"
			_tmp10_ = folks_name_details_get_full_name (_tmp9_);
#line 161 "../src/contacts-avatar.vala"
			_tmp11_ = _tmp10_;
#line 161 "../src/contacts-avatar.vala"
			_tmp12_ = g_strdup (_tmp11_);
#line 161 "../src/contacts-avatar.vala"
			result = _tmp12_;
#line 161 "../src/contacts-avatar.vala"
			_g_object_unref0 (n);
#line 161 "../src/contacts-avatar.vala"
			return result;
#line 1080 "contacts-avatar.c"
		} else {
			FolksNameDetails* _tmp13_;
			FolksStructuredName* _tmp14_;
			FolksStructuredName* _tmp15_;
#line 162 "../src/contacts-avatar.vala"
			_tmp13_ = n;
#line 162 "../src/contacts-avatar.vala"
			_tmp14_ = folks_name_details_get_structured_name (_tmp13_);
#line 162 "../src/contacts-avatar.vala"
			_tmp15_ = _tmp14_;
#line 162 "../src/contacts-avatar.vala"
			if (_tmp15_ != NULL) {
#line 1093 "contacts-avatar.c"
				FolksNameDetails* _tmp16_;
				FolksStructuredName* _tmp17_;
				FolksStructuredName* _tmp18_;
				gchar* _tmp19_;
#line 163 "../src/contacts-avatar.vala"
				_tmp16_ = n;
#line 163 "../src/contacts-avatar.vala"
				_tmp17_ = folks_name_details_get_structured_name (_tmp16_);
#line 163 "../src/contacts-avatar.vala"
				_tmp18_ = _tmp17_;
#line 163 "../src/contacts-avatar.vala"
				_tmp19_ = folks_structured_name_to_string (_tmp18_);
#line 163 "../src/contacts-avatar.vala"
				result = _tmp19_;
#line 163 "../src/contacts-avatar.vala"
				_g_object_unref0 (n);
#line 163 "../src/contacts-avatar.vala"
				return result;
#line 1112 "contacts-avatar.c"
			} else {
				FolksNameDetails* _tmp20_;
				const gchar* _tmp21_;
				const gchar* _tmp22_;
#line 164 "../src/contacts-avatar.vala"
				_tmp20_ = n;
#line 164 "../src/contacts-avatar.vala"
				_tmp21_ = folks_name_details_get_nickname (_tmp20_);
#line 164 "../src/contacts-avatar.vala"
				_tmp22_ = _tmp21_;
#line 164 "../src/contacts-avatar.vala"
				if (g_strcmp0 (_tmp22_, "") != 0) {
#line 1125 "contacts-avatar.c"
					FolksNameDetails* _tmp23_;
					const gchar* _tmp24_;
					const gchar* _tmp25_;
					gchar* _tmp26_;
#line 165 "../src/contacts-avatar.vala"
					_tmp23_ = n;
#line 165 "../src/contacts-avatar.vala"
					_tmp24_ = folks_name_details_get_nickname (_tmp23_);
#line 165 "../src/contacts-avatar.vala"
					_tmp25_ = _tmp24_;
#line 165 "../src/contacts-avatar.vala"
					_tmp26_ = g_strdup (_tmp25_);
#line 165 "../src/contacts-avatar.vala"
					result = _tmp26_;
#line 165 "../src/contacts-avatar.vala"
					_g_object_unref0 (n);
#line 165 "../src/contacts-avatar.vala"
					return result;
#line 1144 "contacts-avatar.c"
				}
			}
		}
	}
#line 168 "../src/contacts-avatar.vala"
	_tmp27_ = g_strdup ("");
#line 168 "../src/contacts-avatar.vala"
	result = _tmp27_;
#line 168 "../src/contacts-avatar.vala"
	_g_object_unref0 (n);
#line 168 "../src/contacts-avatar.vala"
	return result;
#line 1157 "contacts-avatar.c"
}

static void
contacts_avatar_class_init (ContactsAvatarClass * klass,
                            gpointer klass_data)
{
#line 26 "../src/contacts-avatar.vala"
	contacts_avatar_parent_class = g_type_class_peek_parent (klass);
#line 26 "../src/contacts-avatar.vala"
	g_type_class_adjust_private_offset (klass, &ContactsAvatar_private_offset);
#line 26 "../src/contacts-avatar.vala"
	((GtkWidgetClass *) klass)->draw = (gboolean (*) (GtkWidget*, cairo_t*)) contacts_avatar_real_draw;
#line 26 "../src/contacts-avatar.vala"
	G_OBJECT_CLASS (klass)->finalize = contacts_avatar_finalize;
#line 1172 "contacts-avatar.c"
}

static void
contacts_avatar_instance_init (ContactsAvatar * self,
                               gpointer klass)
{
#line 26 "../src/contacts-avatar.vala"
	self->priv = contacts_avatar_get_instance_private (self);
#line 28 "../src/contacts-avatar.vala"
	self->priv->pixbuf = NULL;
#line 29 "../src/contacts-avatar.vala"
	self->priv->cache = NULL;
#line 31 "../src/contacts-avatar.vala"
	self->priv->contact = NULL;
#line 34 "../src/contacts-avatar.vala"
	self->priv->avatar_loaded = FALSE;
#line 1189 "contacts-avatar.c"
}

static void
contacts_avatar_finalize (GObject * obj)
{
	ContactsAvatar * self;
#line 26 "../src/contacts-avatar.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, CONTACTS_TYPE_AVATAR, ContactsAvatar);
#line 28 "../src/contacts-avatar.vala"
	_g_object_unref0 (self->priv->pixbuf);
#line 29 "../src/contacts-avatar.vala"
	_g_object_unref0 (self->priv->cache);
#line 31 "../src/contacts-avatar.vala"
	_g_object_unref0 (self->priv->contact);
#line 26 "../src/contacts-avatar.vala"
	G_OBJECT_CLASS (contacts_avatar_parent_class)->finalize (obj);
#line 1206 "contacts-avatar.c"
}

/**
 * The Avatar of a Contact is responsible for showing an {@link Folks.Individual}'s
 * avatar, or a fallback if it's not available.
 */
GType
contacts_avatar_get_type (void)
{
	static volatile gsize contacts_avatar_type_id__volatile = 0;
	if (g_once_init_enter (&contacts_avatar_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (ContactsAvatarClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) contacts_avatar_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (ContactsAvatar), 0, (GInstanceInitFunc) contacts_avatar_instance_init, NULL };
		GType contacts_avatar_type_id;
		contacts_avatar_type_id = g_type_register_static (gtk_drawing_area_get_type (), "ContactsAvatar", &g_define_type_info, 0);
		ContactsAvatar_private_offset = g_type_add_instance_private (contacts_avatar_type_id, sizeof (ContactsAvatarPrivate));
		g_once_init_leave (&contacts_avatar_type_id__volatile, contacts_avatar_type_id);
	}
	return contacts_avatar_type_id__volatile;
}

